select * from Student;

insert into Student
output Inserted.FirstName, Inserted.LastName
values ('Tom','Jones','MUS300')
---------------------------------------------
declare @Names Table
(First varchar(50),
 Last varchar(50));

insert into Student
output Inserted.FirstName, Inserted.LastName into @Names
values ('Tom2','Jones2','MUS400');

select * from @Names;
------------------------------------
delete from Student
output Deleted.FirstName, Deleted.LastName, Deleted.Course
where FirstName like '%Tom%'
------------------------------------
Select * from Student;

declare @AffectedNames Table
(OldFirst varchar(50),
 OldLast varchar(50),
 NewFirst varchar(50),
 NewLast varchar(50));

update Student
set FirstName = 'Jimmy'
output Deleted.FirstName, Deleted.LastName,
       Inserted.FirstName, Inserted.LastName
	   into @AffectedNames
where LastName = 'Well'

Select * from @AffectedNames
--------------------------------------------------
merge Student as target
using (select 'TestFirst', 'TestLast', 'TestCourse2') as source(FirstName, LastName, Course) 
on (target.FirstName = source.FirstName and target.LastName = source.LastName)
when matched then 
	update set Course = source.Course
when not matched then
	insert (FirstName, LastName, Course)
	values(source.FirstName, source.LastName, source.Course)
	output deleted.*, $action, inserted.*;